diff --git a/src/main/java/net/minecraft/core/net/packet/Packet20NamedEntitySpawn.java b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
similarity index 69%
rename from src/main/java/net/minecraft/core/net/packet/Packet20NamedEntitySpawn.java
rename to src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
index 20cb02494..fcbcfce32 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet20NamedEntitySpawn.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
@@ -1,30 +1,30 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.net.handler.NetHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, EntityPlayer, MathHelper, InventoryPlayer, 
-//            ItemStack, NetHandler
+//            Packet, Player, MathHelper, InventoryPlayer,
+//            ItemStack, PacketHandler
 
-public class Packet20NamedEntitySpawn extends Packet
+public class AddPlayerPacket extends Packet
 {
 
-    public Packet20NamedEntitySpawn()
+    public AddPlayerPacket()
     {
     }
 
-    public Packet20NamedEntitySpawn(EntityPlayer entityplayer)
+    public AddPlayerPacket(Player entityplayer)
     {
         entityId = entityplayer.id;
         name = entityplayer.username;
-        xPosition = MathHelper.floor_double(entityplayer.x * 32D);
-        yPosition = MathHelper.floor_double(entityplayer.y * 32D);
-        zPosition = MathHelper.floor_double(entityplayer.z * 32D);
+        xPosition = MathHelper.floor(entityplayer.x * 32D);
+        yPosition = MathHelper.floor(entityplayer.y * 32D);
+        zPosition = MathHelper.floor(entityplayer.z * 32D);
         rotation = (byte)(int)((entityplayer.yRot * 256F) / 360F);
         pitch = (byte)(int)((entityplayer.xRot * 256F) / 360F);
         ItemStack itemstack = entityplayer.inventory.getCurrentItem();
@@ -34,7 +34,7 @@ public class Packet20NamedEntitySpawn extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         entityId = dis.readInt();
@@ -50,7 +50,7 @@ public class Packet20NamedEntitySpawn extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(entityId);
@@ -66,13 +66,13 @@ public class Packet20NamedEntitySpawn extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleNamedEntitySpawn(this);
+        packetHandler.handleNamedEntitySpawn(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 28;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet18Animation.java b/src/main/java/net/minecraft/core/net/packet/AnimatePacket.java
similarity index 57%
rename from src/main/java/net/minecraft/core/net/packet/Packet18Animation.java
rename to src/main/java/net/minecraft/core/net/packet/AnimatePacket.java
index f2ea269b7..1a6656f8f 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet18Animation.java
+++ b/src/main/java/net/minecraft/core/net/packet/AnimatePacket.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, Entity, NetHandler
+//            Packet, Entity, PacketHandler
 
-public class Packet18Animation extends Packet
+public class AnimatePacket extends Packet
 {
 
-    public Packet18Animation()
+    public AnimatePacket()
     {
     }
 
-    public Packet18Animation(Entity entity, int i)
+    public AnimatePacket(Entity entity, int i)
     {
         entityId = entity.id;
         animate = i;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         entityId = dis.readInt();
@@ -30,7 +30,7 @@ public class Packet18Animation extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(entityId);
@@ -38,13 +38,13 @@ public class Packet18Animation extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleAnimation(this);
+        packetHandler.handleAnimation(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 5;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/BedMessagePacket.java b/src/main/java/net/minecraft/core/net/packet/BedMessagePacket.java
new file mode 100644
index 000000000..5b2efa0b9
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/BedMessagePacket.java
@@ -0,0 +1,53 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class BedMessagePacket extends Packet
+{
+
+    public BedMessagePacket()
+    {
+    }
+    
+    public BedMessagePacket(int state)
+    {
+    	bedState = state;
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        bedState = dis.readByte();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeByte(bedState);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleBed(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 1;
+    }
+
+    public static final String[] BED_MESSAGE_KEYS = {
+        "bed.notValid", null, null
+    };
+    public int bedState;
+
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet140TileEntityData.java b/src/main/java/net/minecraft/core/net/packet/BlockEntityDataPacket.java
similarity index 50%
rename from src/main/java/net/minecraft/core/net/packet/Packet140TileEntityData.java
rename to src/main/java/net/minecraft/core/net/packet/BlockEntityDataPacket.java
index 7428ac138..fe9288124 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet140TileEntityData.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockEntityDataPacket.java
@@ -1,52 +1,51 @@
 package net.minecraft.core.net.packet;
 
 import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.NbtIo;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
-public class Packet140TileEntityData
+public class BlockEntityDataPacket
     extends Packet
 {
     public CompoundTag tag;
 
-    public Packet140TileEntityData()
+    public BlockEntityDataPacket()
     {
         isChunkDataPacket = true;
     }
 
-    public Packet140TileEntityData(TileEntity tileEntity)
+    public BlockEntityDataPacket(BlockEntity blockEntity)
     {
         this();
 
         tag = new CompoundTag();
-        tileEntity.writeToNBT(tag);
+        blockEntity.writeToNBT(tag);
     }
 
     @Override
-    public void readPacketData(DataInputStream dis)
+    public void read(DataInputStream dis)
             throws IOException
     {
         tag = readCompressedCompoundTag(dis);
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos)
+    public void write(DataOutputStream dos)
             throws IOException
     {
         writeCompressedCompoundTag(tag, dos);
     }
 
     @Override
-    public void processPacket(NetHandler netHandler)
+    public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleTileEntityData(this);
+        packetHandler.handleTileEntityData(this);
     }
 
     @Override
-    public int getPacketSize()
+    public int getEstimatedSize()
     {
         return 0;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet54PlayNoteBlock.java b/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
similarity index 66%
rename from src/main/java/net/minecraft/core/net/packet/Packet54PlayNoteBlock.java
rename to src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
index 14e7e3fd7..9bb9a2cad 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet54PlayNoteBlock.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockEventPacket.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet54PlayNoteBlock extends Packet
+public class BlockEventPacket extends Packet
 {
 
-    public Packet54PlayNoteBlock()
+    public BlockEventPacket()
     {
     }
     
-    public Packet54PlayNoteBlock(int i, int j, int k, int l, int i1)
+    public BlockEventPacket(int i, int j, int k, int l, int i1)
     {
         xLocation = i;
         yLocation = j;
@@ -24,7 +24,7 @@ public class Packet54PlayNoteBlock extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xLocation = dis.readInt();
@@ -35,7 +35,7 @@ public class Packet54PlayNoteBlock extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xLocation);
@@ -46,13 +46,13 @@ public class Packet54PlayNoteBlock extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handlePlayNoteBlock(this);
+        packetHandler.handlePlayNoteBlock(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 12;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet51MapChunk.java b/src/main/java/net/minecraft/core/net/packet/BlockRegionUpdatePacket.java
similarity index 82%
rename from src/main/java/net/minecraft/core/net/packet/Packet51MapChunk.java
rename to src/main/java/net/minecraft/core/net/packet/BlockRegionUpdatePacket.java
index e4b1e53b8..6c91d1f01 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet51MapChunk.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockRegionUpdatePacket.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.packet;
 
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.world.World;
-import net.minecraft.core.net.handler.NetHandler;
 
 import java.io.*;
 import java.util.zip.DataFormatException;
@@ -9,17 +9,17 @@ import java.util.zip.Deflater;
 import java.util.zip.Inflater;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet51MapChunk extends Packet
+public class BlockRegionUpdatePacket extends Packet
 {
 
-    public Packet51MapChunk()
+    public BlockRegionUpdatePacket()
     {
         isChunkDataPacket = true;
     }
     
-    public Packet51MapChunk(int xPosition, int yPosition, int zPosition, int xSize, int ySize, int zSize, World world)
+    public BlockRegionUpdatePacket(int xPosition, int yPosition, int zPosition, int xSize, int ySize, int zSize, World world)
     {
         isChunkDataPacket = true;
 
@@ -46,7 +46,7 @@ public class Packet51MapChunk extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         // Read data
@@ -79,7 +79,7 @@ public class Packet51MapChunk extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xPosition);
@@ -93,13 +93,13 @@ public class Packet51MapChunk extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleMapChunk(this);
+        packetHandler.handleMapChunk(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 4 + 2 + 4 + 1 + 1 + 1 + 4 + chunkSize;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet53BlockChange.java b/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
similarity index 70%
rename from src/main/java/net/minecraft/core/net/packet/Packet53BlockChange.java
rename to src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
index 3b3e75f36..e98e62071 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet53BlockChange.java
+++ b/src/main/java/net/minecraft/core/net/packet/BlockUpdatePacket.java
@@ -1,22 +1,22 @@
 package net.minecraft.core.net.packet;
 
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.world.World;
-import net.minecraft.core.net.handler.NetHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet53BlockChange extends Packet
+public class BlockUpdatePacket extends Packet
 {
 
-    public Packet53BlockChange()
+    public BlockUpdatePacket()
     {
         isChunkDataPacket = true;
     }
     
-    public Packet53BlockChange(int i, int j, int k, World world)
+    public BlockUpdatePacket(int i, int j, int k, World world)
     {
         isChunkDataPacket = true;
         xPosition = i;
@@ -27,7 +27,7 @@ public class Packet53BlockChange extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xPosition = dis.readInt();
@@ -38,7 +38,7 @@ public class Packet53BlockChange extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xPosition);
@@ -49,13 +49,13 @@ public class Packet53BlockChange extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleBlockChange(this);
+        packetHandler.handleBlockChange(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 11;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet26BoatControl.java b/src/main/java/net/minecraft/core/net/packet/BoatControlPacket.java
similarity index 63%
rename from src/main/java/net/minecraft/core/net/packet/Packet26BoatControl.java
rename to src/main/java/net/minecraft/core/net/packet/BoatControlPacket.java
index b9b9a1808..0e4762e4a 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet26BoatControl.java
+++ b/src/main/java/net/minecraft/core/net/packet/BoatControlPacket.java
@@ -1,26 +1,26 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet26BoatControl extends Packet{
+public class BoatControlPacket extends Packet{
     public int entityId;
     public float targetXD;
     public float targetZD;
     public float targetYRot;
-    public Packet26BoatControl(){}
-    public Packet26BoatControl(Entity entity){
+    public BoatControlPacket(){}
+    public BoatControlPacket(Entity entity){
         entityId = entity.id;
         targetXD = (float) entity.xd;
         targetZD = (float) entity.zd;
         targetYRot = entity.yRot;
     }
     @Override
-    public void readPacketData(DataInputStream dis) throws IOException {
+    public void read(DataInputStream dis) throws IOException {
         entityId = dis.readInt();
         targetXD = dis.readFloat();
         targetZD = dis.readFloat();
@@ -28,7 +28,7 @@ public class Packet26BoatControl extends Packet{
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos) throws IOException {
+    public void write(DataOutputStream dos) throws IOException {
         dos.writeInt(entityId);
         dos.writeFloat(targetXD);
         dos.writeFloat(targetZD);
@@ -36,12 +36,12 @@ public class Packet26BoatControl extends Packet{
     }
 
     @Override
-    public void processPacket(NetHandler netHandler) {
-        netHandler.handleBoatControl(this);
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleBoatControl(this);
     }
 
     @Override
-    public int getPacketSize() {
+    public int getEstimatedSize() {
         return 12;
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java b/src/main/java/net/minecraft/core/net/packet/ChatPacket.java
similarity index 70%
rename from src/main/java/net/minecraft/core/net/packet/Packet3Chat.java
rename to src/main/java/net/minecraft/core/net/packet/ChatPacket.java
index 73bd3618c..2067a6458 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java
+++ b/src/main/java/net/minecraft/core/net/packet/ChatPacket.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.AES;
 
 import java.io.*;
 import java.security.Key;
 
-public class Packet3Chat extends Packet {
+public class ChatPacket extends Packet {
 	
 	public static final String ENCRYPTION_ERROR_MESSAGE = "This crash is caused by outdated Java, please update to 8u161 or newer! If your Java version is out of date due to a technical requirement, please add the JCE Unlimited Strength Jurisdiction Policy Files to your installation. https://www.oracle.com/java/technologies/javase-jce-all-downloads.html";
 	
@@ -14,19 +14,19 @@ public class Packet3Chat extends Packet {
 	public int type;
 	public boolean encrypted;
 
-	public Packet3Chat() {
+	public ChatPacket() {
 		
 	}
 
-	public Packet3Chat(String string) {
+	public ChatPacket(String string) {
 		this(string, 0, null);
 	}
 
-	public Packet3Chat(String string, Key key) {
+	public ChatPacket(String string, Key key) {
 		this(string, 0, key);
 	}
 	
-	public Packet3Chat(String string, int type, Key key) {
+	public ChatPacket(String string, int type, Key key) {
 		if(string.length() > 512) {
 			string = string.substring(0, 512);
 		}
@@ -45,26 +45,26 @@ public class Packet3Chat extends Packet {
 	}
 
 	@Override
-	public void readPacketData(DataInputStream in) throws IOException {
+	public void read(DataInputStream in) throws IOException {
 		type = in.readByte();
 		message = readString(in, 1024);
 		encrypted = in.readBoolean();
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream out) throws IOException {
+	public void write(DataOutputStream out) throws IOException {
 		out.writeByte(type);
 		writeString(message, out);
 		out.writeBoolean(encrypted);
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleChat(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleChat(this);
 	}
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return message.length() + 1;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet52MultiBlockChange.java b/src/main/java/net/minecraft/core/net/packet/ChunkBlocksUpdatePacket.java
similarity index 81%
rename from src/main/java/net/minecraft/core/net/packet/Packet52MultiBlockChange.java
rename to src/main/java/net/minecraft/core/net/packet/ChunkBlocksUpdatePacket.java
index b6d5ccd3c..82db24948 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet52MultiBlockChange.java
+++ b/src/main/java/net/minecraft/core/net/packet/ChunkBlocksUpdatePacket.java
@@ -2,22 +2,22 @@ package net.minecraft.core.net.packet;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet52MultiBlockChange extends Packet
+public class ChunkBlocksUpdatePacket extends Packet
 {
 
-    public Packet52MultiBlockChange()
+    public ChunkBlocksUpdatePacket()
     {
         isChunkDataPacket = true;
     }
     
-    public Packet52MultiBlockChange(int xChunk, int zChunk, int[] blocksToUpdate, int numBlocksToUpdate, World world)
+    public ChunkBlocksUpdatePacket(int xChunk, int zChunk, int[] blocksToUpdate, int numBlocksToUpdate, World world)
     {
         isChunkDataPacket = true;
         this.xChunk = xChunk;
@@ -40,7 +40,7 @@ public class Packet52MultiBlockChange extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xChunk = dis.readInt();
@@ -62,7 +62,7 @@ public class Packet52MultiBlockChange extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xChunk);
@@ -81,13 +81,13 @@ public class Packet52MultiBlockChange extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleMultiBlockChange(this);
+        packetHandler.handleMultiBlockChange(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 10 + size * 4;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet50PreChunk.java b/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
similarity index 62%
rename from src/main/java/net/minecraft/core/net/packet/Packet50PreChunk.java
rename to src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
index af1a8da88..6521a39ef 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet50PreChunk.java
+++ b/src/main/java/net/minecraft/core/net/packet/ChunkVisibilityPacket.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet50PreChunk extends Packet
+public class ChunkVisibilityPacket extends Packet
 {
 
-    public Packet50PreChunk()
+    public ChunkVisibilityPacket()
     {
         isChunkDataPacket = false;
     }
     
-    public Packet50PreChunk(int i, int j, boolean flag)
+    public ChunkVisibilityPacket(int i, int j, boolean flag)
     {
         isChunkDataPacket = false;
         xPosition = i;
@@ -24,7 +24,7 @@ public class Packet50PreChunk extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xPosition = dis.readInt();
@@ -33,7 +33,7 @@ public class Packet50PreChunk extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xPosition);
@@ -42,13 +42,13 @@ public class Packet50PreChunk extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handlePreChunk(this);
+        packetHandler.handlePreChunk(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 9;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java b/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java
new file mode 100644
index 000000000..4b29d83ce
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerAckPacket.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class ContainerAckPacket extends Packet
+{
+
+    public ContainerAckPacket()
+    {
+    }
+
+    public ContainerAckPacket(int i, short word0, boolean flag)
+    {
+        windowId = i;
+        shortWindowId = word0;
+        accepted = flag;
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleTransaction(this);
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        windowId = dis.readByte();
+        shortWindowId = dis.readShort();
+        accepted = dis.readByte() != 0;
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeByte(windowId);
+        dos.writeShort(shortWindowId);
+        dos.writeByte(accepted ? 1 : 0);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 4;
+    }
+
+    public int windowId;
+    public short shortWindowId;
+    public boolean accepted;
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet102WindowClick.java b/src/main/java/net/minecraft/core/net/packet/ContainerClickPacket.java
similarity index 79%
rename from src/main/java/net/minecraft/core/net/packet/Packet102WindowClick.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerClickPacket.java
index 1d7ab4e66..d4785fcdb 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet102WindowClick.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerClickPacket.java
@@ -2,19 +2,19 @@ package net.minecraft.core.net.packet;
 
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler, ItemStack
+//            Packet, PacketHandler, ItemStack
 
-public class Packet102WindowClick extends Packet {
+public class ContainerClickPacket extends Packet {
 
-	public Packet102WindowClick() {
+	public ContainerClickPacket() {
 	}
 
-	public Packet102WindowClick(int windowId, InventoryAction action, int[] args, ItemStack itemstack, short actionId) {
+	public ContainerClickPacket(int windowId, InventoryAction action, int[] args, ItemStack itemstack, short actionId) {
 		this.window_Id = windowId;
 		this.action = action;
 		this.args = args;
@@ -23,12 +23,12 @@ public class Packet102WindowClick extends Packet {
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleWindowClick(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleWindowClick(this);
 	}
 
 	@Override
-	public void readPacketData(DataInputStream dis) throws IOException {
+	public void read(DataInputStream dis) throws IOException {
 		window_Id = dis.readByte();
 		action = InventoryAction.get(dis.readByte());
 		
@@ -50,7 +50,7 @@ public class Packet102WindowClick extends Packet {
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(window_Id);
@@ -85,7 +85,7 @@ public class Packet102WindowClick extends Packet {
     }
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return 7 + (args != null ? args.length : 0);
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet101CloseWindow.java b/src/main/java/net/minecraft/core/net/packet/ContainerClosePacket.java
similarity index 50%
rename from src/main/java/net/minecraft/core/net/packet/Packet101CloseWindow.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerClosePacket.java
index e3da6f484..d58b8aeb2 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet101CloseWindow.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerClosePacket.java
@@ -1,46 +1,46 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet101CloseWindow extends Packet
+public class ContainerClosePacket extends Packet
 {
 
-    public Packet101CloseWindow()
+    public ContainerClosePacket()
     {
     }
 
-    public Packet101CloseWindow(int i)
+    public ContainerClosePacket(int i)
     {
         windowId = i;
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleCloseWindow(this);
+        packetHandler.handleCloseWindow(this);
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 1;
     }
